Imports System.Runtime.InteropServices
Imports System
Imports System.Windows.Forms

Public Class Form1
    Inherits System.Windows.Forms.Form
    Public Const WM_COPYDATA As Integer = &H4A

    Private Const WM_SM_REGISTER As Integer = &H8100
    Private Const WM_SM_UNREGISTER As Integer = &H8101
    Private Const ERROR_SUCCESS As Integer = 0
    Private Const WM_SM_STARTSTOP As Integer = &H8102
    Private Const WM_SM_GETSTATE As Integer = &H8105
    Private Const SM_RESULT_STARTED As Integer = 256
    Private Const SM_RESULT_STOPPED As Integer = 512
    Private Const LPTR As Integer = &H40

    Private bRegistered As Boolean = False

    <DllImport("User32", CharSet:=CharSet.Auto)> _
    Private Shared Function FindWindow(ByVal className As String, ByVal WindowsName As String) As IntPtr
    End Function

    <DllImport("User32", CharSet:=CharSet.Auto)> _
    Private Shared Function SendMessage(ByVal hwnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As IntPtr) As Integer
    End Function

    <DllImport("User32", CharSet:=CharSet.Auto)> _
    Private Shared Function SendMessage(ByVal hwnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Integer
    End Function

    <DllImport("Kernel32", CharSet:=CharSet.Auto)> _
    Private Shared Function LocalAlloc(ByVal flag As Integer, ByVal val As Integer) As IntPtr
    End Function

    <DllImport("Kernel32", CharSet:=CharSet.Auto)> _
    Private Shared Function LocalFree(ByVal p As IntPtr) As UIntPtr
    End Function

    Public Structure COPYDATASTRUCT
        Public dwData As IntPtr
        Public cbData As Integer
        Public lpData As IntPtr
    End Structure
    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)
        bRegistered = False
    End Sub
    Public Sub Form1()
        InitializeComponent()
    End Sub

    Public Sub RespondToMessage(ByVal x As Integer, ByVal y As Integer)
        Me.Text = "X = " + x.ToString() + ", Y= " + y.ToString()
    End Sub

    Private Sub registerMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles registerMenuItem.Click
        logListBox.Items.Add("Searching for SerialMagic window:")

        Dim foundWindow As IntPtr
        Dim rslt As Integer

        foundWindow = FindWindow(vbNullString, "SerialMagic Professional - Direct Data Mode")

        If (foundWindow <> IntPtr.Zero) Then
            logListBox.Items.Add(" - SerialMagic was found.")
            logListBox.Items.Add("Registering to SerialMagic:")

            rslt = -1
            rslt = SendMessage(foundWindow, WM_SM_REGISTER, 0, MyBase.Handle)

            If (rslt = ERROR_SUCCESS) Then
                logListBox.Items.Add(" - success.")
                bRegistered = True
            Else
                logListBox.Items.Add(" - fail.")
            End If
        Else
            logListBox.Items.Add(" - SerialMagic wasn't found.")
        End If
        logListBox.SelectedIndex = logListBox.Items.Count - 1

    End Sub

    Private Sub unregisterMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles unregisterMenuItem.Click
        Dim foundWindow As IntPtr = IntPtr.Zero
        Dim rslt As Integer = -1

        foundWindow = FindWindow(vbNullString, "SerialMagic Professional - Direct Data Mode")

        If (foundWindow <> IntPtr.Zero) Then
            logListBox.Items.Add("Unregistering to SerialMagic:")

            rslt = SendMessage(foundWindow, WM_SM_UNREGISTER, 0, MyBase.Handle)

            If (rslt = ERROR_SUCCESS) Then
                logListBox.Items.Add(" - success.")
                bRegistered = False
            Else
                logListBox.Items.Add(" - fail.")
            End If
        Else
            logListBox.Items.Add(" - SerialMagic wasn't found.")
            logListBox.Items.Add(" - Enable Post Direct Data setting in SerialMagic")
        End If
        logListBox.SelectedIndex = logListBox.Items.Count - 1

    End Sub

    Public Sub CopyData(ByRef m As System.Windows.Forms.Message)
        Dim cds As COPYDATASTRUCT
        'MsgBox("CopyData")
        cds = CType(Marshal.PtrToStructure(m.LParam, GetType(COPYDATASTRUCT)), COPYDATASTRUCT)

        If (cds.cbData > 0) Then
            Dim tmpString As String = "Have incoming data:" + cds.cbData.ToString()
            logListBox.Items.Add(tmpString)

            Dim datab() As Byte
            datab = New Byte() {}
            ReDim datab(cds.cbData)
            Marshal.Copy(cds.lpData, datab, 0, cds.cbData)
            tmpString = System.Text.Encoding.ASCII.GetString(datab, 0, cds.cbData)

            logListBox.SelectedIndex = logListBox.Items.Add(tmpString)
        End If
    End Sub


    Private Sub exitMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exitMenuItem.Click
        Close()
    End Sub

    Private Sub aboutMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles aboutMenuItem.Click
        AboutForm.ShowDialog()
    End Sub

    Protected Overrides Sub WndProc(ByRef msg As System.Windows.Forms.Message)
        Select Case msg.Msg
            ' If message is of interest, invoke the method on the form that
            ' functions as a callback to perform actions in response to the message.
            Case WM_COPYDATA

                CopyData(msg)
        End Select

        ' Call the base class WndProc method
        ' to process any messages not handled.
        MyBase.WndProc(msg)
    End Sub

    Private Function GetAppState() As Boolean
        Dim foundWindow As IntPtr = IntPtr.Zero
        Dim rslt As Boolean = False

        foundWindow = FindWindow(vbNullString, "SerialMagic Professional - Direct Data Mode")

        If (foundWindow <> IntPtr.Zero) Then
            If SendMessage(foundWindow, WM_SM_GETSTATE, 0, MyBase.Handle) = SM_RESULT_STARTED Then
                rslt = True
            End If
        End If
        Return rslt

    End Function
    Private Sub startMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles startMenuItem.Click
        Dim foundWindow As IntPtr = IntPtr.Zero
        Dim rslt As Integer = -1

        foundWindow = FindWindow(vbNullString, "SerialMagic Professional - Direct Data Mode")

        If (foundWindow <> IntPtr.Zero) Then
            rslt = SendMessage(foundWindow, WM_SM_STARTSTOP, 0, MyBase.Handle)

            If (rslt = SM_RESULT_STARTED) Then
                logListBox.Items.Add(" - started.")
            Else
                If (rslt = SM_RESULT_STOPPED) Then
                    logListBox.Items.Add(" - stopped.")
                Else
                    logListBox.Items.Add(" - fail.")
                End If
            End If
        Else
            logListBox.Items.Add(" - SerialMagic wasn't found.")
        End If
        logListBox.SelectedIndex = logListBox.Items.Count - 1
        If (GetAppState()) Then
            startMenuItem.Text = "Stop"
        Else
            startMenuItem.Text = "Start"
        End If
    End Sub

    Private Sub sendMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles sendMenuItem.Click
        If (bRegistered = 0) Then
            logListBox.SelectedIndex = logListBox.Items.Add("Application wasn't registered to SerialMagic")
            Return
        End If

        If (dataTextBox.Text = "") Then
            logListBox.SelectedIndex = logListBox.Items.Add("Nothing to send to SerialMagic")
            Return
        End If

        Dim foundWindow As IntPtr = vbNull
        foundWindow = FindWindow(vbNullString, "SerialMagic Professional - Direct Data Mode")

        If (foundWindow = 0) Then
            logListBox.SelectedIndex = logListBox.Items.Add("SerialMagic wasn't found:")
            Return
        End If

        logListBox.SelectedIndex = logListBox.Items.Add("Send data to SerialMagic:")

        Dim lParam As IntPtr = IntPtr.Zero
        Dim bytesPtr As IntPtr = IntPtr.Zero

        If (HexCheckBox.Checked = True) Then
            Dim str As String = dataTextBox.Text
            Dim strs() As String = str.Split(" ")
            Dim bytes() As Byte = New Byte(strs.Length) {}
            Dim i As Integer = 0

            For i = 0 To strs.Length - 1
                Dim pair As String = ""
                pair = strs(i)
                Try
                    bytes(i) = Convert.ToByte(pair, 16)
                Catch
                    logListBox.Items.Add("Invalid input format")
                    Return
                End Try
            Next

            bytesPtr = LocalAlloc(LPTR, strs.Length)

            Marshal.Copy(bytes, 0, bytesPtr, strs.Length)

            Dim cbs As COPYDATASTRUCT = New COPYDATASTRUCT()
            cbs.dwData = 0
            cbs.cbData = strs.Length
            cbs.lpData = bytesPtr

            lParam = LocalAlloc(LPTR, Marshal.SizeOf(cbs))
            Marshal.StructureToPtr(cbs, lParam, False)
        Else
            Dim bytes() As Byte = System.Text.Encoding.ASCII.GetBytes(dataTextBox.Text)

            bytesPtr = LocalAlloc(LPTR, bytes.Length + 1)

            Marshal.Copy(bytes, 0, bytesPtr, bytes.Length)

            Dim cbs As COPYDATASTRUCT = New COPYDATASTRUCT()
            cbs.dwData = 0
            cbs.cbData = dataTextBox.Text.Length
            cbs.lpData = bytesPtr

            lParam = LocalAlloc(LPTR, Marshal.SizeOf(cbs))
            Marshal.StructureToPtr(cbs, lParam, False)
        End If

        Dim res As Integer = SendMessage(foundWindow, WM_COPYDATA, MyBase.Handle, lParam)
        If (res = 1) Then
            logListBox.SelectedIndex = logListBox.Items.Add("- success.")
        Else
            logListBox.SelectedIndex = logListBox.Items.Add("- fail.")
        End If

        LocalFree(bytesPtr)
        LocalFree(lParam)

    End Sub
End Class
